Merge branch 'jc/do-not-let-random-file-interfere-with-completion-tests' into maint
[git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Keep the original TERM for say_color
19 ORIGINAL_TERM=$TERM
20
21 # Test the binaries we have just built.  The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
24 then
25         # We allow tests to override this, in case they want to run tests
26         # outside of t/, e.g. for running tests on the test library
27         # itself.
28         TEST_DIRECTORY=$(pwd)
29 fi
30 if test -z "$TEST_OUTPUT_DIRECTORY"
31 then
32         # Similarly, override this to store the test-results subdir
33         # elsewhere
34         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35 fi
36 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev/null
41 if test $? != 1
42 then
43         echo >&2 'error: you do not seem to have built git yet.'
44         exit 1
45 fi
46
47 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
49
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
53 done,*)
54         # do not redirect again
55         ;;
56 *' --tee '*|*' --va'*)
57         mkdir -p test-results
58         BASE=test-results/$(basename "$0" .sh)
59         (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60          echo $? > $BASE.exit) | tee $BASE.out
61         test "$(cat $BASE.exit)" = 0
62         exit
63         ;;
64 esac
65
66 # For repeatability, reset the environment to known value.
67 LANG=C
68 LC_ALL=C
69 PAGER=cat
70 TZ=UTC
71 TERM=dumb
72 export LANG LC_ALL PAGER TERM TZ
73 EDITOR=:
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
76 # deriving from the command substitution clustered with the other
77 # ones.
78 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
79         my @env = keys %ENV;
80         my $ok = join("|", qw(
81                 TRACE
82                 DEBUG
83                 USE_LOOKUP
84                 TEST
85                 .*_TEST
86                 PROVE
87                 VALGRIND
88                 UNZIP
89                 PERF_AGGREGATING_LATER
90         ));
91         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92         print join("\n", @vars);
93 ')
94 unset XDG_CONFIG_HOME
95 GIT_AUTHOR_EMAIL=author@example.com
96 GIT_AUTHOR_NAME='A U Thor'
97 GIT_COMMITTER_EMAIL=committer@example.com
98 GIT_COMMITTER_NAME='C O Mitter'
99 GIT_MERGE_VERBOSITY=5
100 GIT_MERGE_AUTOEDIT=no
101 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
102 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
104 export EDITOR
105
106 # Add libc MALLOC and MALLOC_PERTURB test
107 # only if we are not executing the test with valgrind
108 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
109    test -n "$TEST_NO_MALLOC_CHECK"
110 then
111         setup_malloc_check () {
112                 : nothing
113         }
114         teardown_malloc_check () {
115                 : nothing
116         }
117 else
118         setup_malloc_check () {
119                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120                 export MALLOC_CHECK_ MALLOC_PERTURB_
121         }
122         teardown_malloc_check () {
123                 unset MALLOC_CHECK_ MALLOC_PERTURB_
124         }
125 fi
126
127 # Protect ourselves from common misconfiguration to export
128 # CDPATH into the environment
129 unset CDPATH
130
131 unset GREP_OPTIONS
132 unset UNZIP
133
134 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
135 1|2|true)
136         echo "* warning: Some tests will not work if GIT_TRACE" \
137                 "is set as to trace on STDERR ! *"
138         echo "* warning: Please set GIT_TRACE to something" \
139                 "other than 1, 2 or true ! *"
140         ;;
141 esac
142
143 # Convenience
144 #
145 # A regexp to match 5 and 40 hexdigits
146 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
149 # Zero SHA-1
150 _z40=0000000000000000000000000000000000000000
151
152 # Line feed
153 LF='
154 '
155
156 export _x05 _x40 _z40 LF
157
158 # Each test should start with something like this, after copyright notices:
159 #
160 # test_description='Description of this test...
161 # This test checks if command xyzzy does the right thing...
162 # '
163 # . ./test-lib.sh
164 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
165                 TERM=$ORIGINAL_TERM &&
166                 export TERM &&
167                 [ -t 1 ] &&
168                 tput bold >/dev/null 2>&1 &&
169                 tput setaf 1 >/dev/null 2>&1 &&
170                 tput sgr0 >/dev/null 2>&1
171         ) &&
172         color=t
173
174 while test "$#" -ne 0
175 do
176         case "$1" in
177         -d|--d|--de|--deb|--debu|--debug)
178                 debug=t; shift ;;
179         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180                 immediate=t; shift ;;
181         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
182                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
183         -h|--h|--he|--hel|--help)
184                 help=t; shift ;;
185         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186                 verbose=t; shift ;;
187         -q|--q|--qu|--qui|--quie|--quiet)
188                 # Ignore --quiet under a TAP::Harness. Saying how many tests
189                 # passed without the ok/not ok details is always an error.
190                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
191         --with-dashes)
192                 with_dashes=t; shift ;;
193         --no-color)
194                 color=; shift ;;
195         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
196                 valgrind=t; verbose=t; shift ;;
197         --tee)
198                 shift ;; # was handled already
199         --root=*)
200                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
201                 shift ;;
202         *)
203                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
204         esac
205 done
206
207 if test -n "$color"
208 then
209         say_color () {
210                 (
211                 TERM=$ORIGINAL_TERM
212                 export TERM
213                 case "$1" in
214                 error)
215                         tput bold; tput setaf 1;; # bold red
216                 skip)
217                         tput bold; tput setaf 2;; # bold green
218                 pass)
219                         tput setaf 2;;            # green
220                 info)
221                         tput setaf 3;;            # brown
222                 *)
223                         test -n "$quiet" && return;;
224                 esac
225                 shift
226                 printf "%s" "$*"
227                 tput sgr0
228                 echo
229                 )
230         }
231 else
232         say_color() {
233                 test -z "$1" && test -n "$quiet" && return
234                 shift
235                 printf "%s\n" "$*"
236         }
237 fi
238
239 error () {
240         say_color error "error: $*"
241         GIT_EXIT_OK=t
242         exit 1
243 }
244
245 say () {
246         say_color info "$*"
247 }
248
249 test "${test_description}" != "" ||
250 error "Test script did not set test_description."
251
252 if test "$help" = "t"
253 then
254         echo "$test_description"
255         exit 0
256 fi
257
258 exec 5>&1
259 exec 6<&0
260 if test "$verbose" = "t"
261 then
262         exec 4>&2 3>&1
263 else
264         exec 4>/dev/null 3>/dev/null
265 fi
266
267 test_failure=0
268 test_count=0
269 test_fixed=0
270 test_broken=0
271 test_success=0
272
273 test_external_has_tap=0
274
275 die () {
276         code=$?
277         if test -n "$GIT_EXIT_OK"
278         then
279                 exit $code
280         else
281                 echo >&5 "FATAL: Unexpected exit with code $code"
282                 exit 1
283         fi
284 }
285
286 GIT_EXIT_OK=
287 trap 'die' EXIT
288
289 # The user-facing functions are loaded from a separate file so that
290 # test_perf subshells can have them too
291 . "$TEST_DIRECTORY/test-lib-functions.sh"
292
293 # You are not expected to call test_ok_ and test_failure_ directly, use
294 # the text_expect_* functions instead.
295
296 test_ok_ () {
297         test_success=$(($test_success + 1))
298         say_color "" "ok $test_count - $@"
299 }
300
301 test_failure_ () {
302         test_failure=$(($test_failure + 1))
303         say_color error "not ok - $test_count $1"
304         shift
305         echo "$@" | sed -e 's/^/#       /'
306         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
307 }
308
309 test_known_broken_ok_ () {
310         test_fixed=$(($test_fixed+1))
311         say_color "" "ok $test_count - $@ # TODO known breakage"
312 }
313
314 test_known_broken_failure_ () {
315         test_broken=$(($test_broken+1))
316         say_color skip "not ok $test_count - $@ # TODO known breakage"
317 }
318
319 test_debug () {
320         test "$debug" = "" || eval "$1"
321 }
322
323 test_eval_ () {
324         # This is a separate function because some tests use
325         # "return" to end a test_expect_success block early.
326         eval </dev/null >&3 2>&4 "$*"
327 }
328
329 test_run_ () {
330         test_cleanup=:
331         expecting_failure=$2
332         test_eval_ "$1"
333         eval_ret=$?
334
335         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
336         then
337                 setup_malloc_check
338                 test_eval_ "$test_cleanup"
339                 teardown_malloc_check
340         fi
341         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
342         then
343                 echo ""
344         fi
345         return "$eval_ret"
346 }
347
348 test_skip () {
349         test_count=$(($test_count+1))
350         to_skip=
351         for skp in $GIT_SKIP_TESTS
352         do
353                 case $this_test.$test_count in
354                 $skp)
355                         to_skip=t
356                         break
357                 esac
358         done
359         if test -z "$to_skip" && test -n "$test_prereq" &&
360            ! test_have_prereq "$test_prereq"
361         then
362                 to_skip=t
363         fi
364         case "$to_skip" in
365         t)
366                 of_prereq=
367                 if test "$missing_prereq" != "$test_prereq"
368                 then
369                         of_prereq=" of $test_prereq"
370                 fi
371
372                 say_color skip >&3 "skipping test: $@"
373                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
374                 : true
375                 ;;
376         *)
377                 false
378                 ;;
379         esac
380 }
381
382 # stub; perf-lib overrides it
383 test_at_end_hook_ () {
384         :
385 }
386
387 test_done () {
388         GIT_EXIT_OK=t
389
390         if test -z "$HARNESS_ACTIVE"
391         then
392                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
393                 mkdir -p "$test_results_dir"
394                 base=${0##*/}
395                 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
396
397                 cat >>"$test_results_path" <<-EOF
398                 total $test_count
399                 success $test_success
400                 fixed $test_fixed
401                 broken $test_broken
402                 failed $test_failure
403
404                 EOF
405         fi
406
407         if test "$test_fixed" != 0
408         then
409                 say_color pass "# fixed $test_fixed known breakage(s)"
410         fi
411         if test "$test_broken" != 0
412         then
413                 say_color error "# still have $test_broken known breakage(s)"
414                 msg="remaining $(($test_count-$test_broken)) test(s)"
415         else
416                 msg="$test_count test(s)"
417         fi
418         case "$test_failure" in
419         0)
420                 # Maybe print SKIP message
421                 if test -n "$skip_all" && test $test_count -gt 0
422                 then
423                         error "Can't use skip_all after running some tests"
424                 fi
425                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
426
427                 if test $test_external_has_tap -eq 0
428                 then
429                         if test $test_count -gt 0
430                         then
431                                 say_color pass "# passed all $msg"
432                         fi
433                         say "1..$test_count$skip_all"
434                 fi
435
436                 test -d "$remove_trash" &&
437                 cd "$(dirname "$remove_trash")" &&
438                 rm -rf "$(basename "$remove_trash")"
439
440                 test_at_end_hook_
441
442                 exit 0 ;;
443
444         *)
445                 if test $test_external_has_tap -eq 0
446                 then
447                         say_color error "# failed $test_failure among $msg"
448                         say "1..$test_count"
449                 fi
450
451                 exit 1 ;;
452
453         esac
454 }
455
456 if test -n "$valgrind"
457 then
458         make_symlink () {
459                 test -h "$2" &&
460                 test "$1" = "$(readlink "$2")" || {
461                         # be super paranoid
462                         if mkdir "$2".lock
463                         then
464                                 rm -f "$2" &&
465                                 ln -s "$1" "$2" &&
466                                 rm -r "$2".lock
467                         else
468                                 while test -d "$2".lock
469                                 do
470                                         say "Waiting for lock on $2."
471                                         sleep 1
472                                 done
473                         fi
474                 }
475         }
476
477         make_valgrind_symlink () {
478                 # handle only executables, unless they are shell libraries that
479                 # need to be in the exec-path.  We will just use "#!" as a
480                 # guess for a shell-script, since we have no idea what the user
481                 # may have configured as the shell path.
482                 test -x "$1" ||
483                 test "#!" = "$(head -c 2 <"$1")" ||
484                 return;
485
486                 base=$(basename "$1")
487                 symlink_target=$GIT_BUILD_DIR/$base
488                 # do not override scripts
489                 if test -x "$symlink_target" &&
490                     test ! -d "$symlink_target" &&
491                     test "#!" != "$(head -c 2 < "$symlink_target")"
492                 then
493                         symlink_target=../valgrind.sh
494                 fi
495                 case "$base" in
496                 *.sh|*.perl)
497                         symlink_target=../unprocessed-script
498                 esac
499                 # create the link, or replace it if it is out of date
500                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
501         }
502
503         # override all git executables in TEST_DIRECTORY/..
504         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
505         mkdir -p "$GIT_VALGRIND"/bin
506         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
507         do
508                 make_valgrind_symlink $file
509         done
510         # special-case the mergetools loadables
511         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
512         OLDIFS=$IFS
513         IFS=:
514         for path in $PATH
515         do
516                 ls "$path"/git-* 2> /dev/null |
517                 while read file
518                 do
519                         make_valgrind_symlink "$file"
520                 done
521         done
522         IFS=$OLDIFS
523         PATH=$GIT_VALGRIND/bin:$PATH
524         GIT_EXEC_PATH=$GIT_VALGRIND/bin
525         export GIT_VALGRIND
526 elif test -n "$GIT_TEST_INSTALLED"
527 then
528         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
529         error "Cannot run git from $GIT_TEST_INSTALLED."
530         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
531         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
532 else # normal case, use ../bin-wrappers only unless $with_dashes:
533         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
534         if ! test -x "$git_bin_dir/git"
535         then
536                 if test -z "$with_dashes"
537                 then
538                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
539                 fi
540                 with_dashes=t
541         fi
542         PATH="$git_bin_dir:$PATH"
543         GIT_EXEC_PATH=$GIT_BUILD_DIR
544         if test -n "$with_dashes"
545         then
546                 PATH="$GIT_BUILD_DIR:$PATH"
547         fi
548 fi
549 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
550 unset GIT_CONFIG
551 GIT_CONFIG_NOSYSTEM=1
552 GIT_ATTR_NOSYSTEM=1
553 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
554
555 if test -z "$GIT_TEST_CMP"
556 then
557         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
558         then
559                 GIT_TEST_CMP="$DIFF -c"
560         else
561                 GIT_TEST_CMP="$DIFF -u"
562         fi
563 fi
564
565 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
566 export GITPERLLIB
567 test -d "$GIT_BUILD_DIR"/templates/blt || {
568         error "You haven't built things yet, have you?"
569 }
570
571 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
572 then
573         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
574         export GITPYTHONLIB
575         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
576                 error "You haven't built git_remote_helpers yet, have you?"
577         }
578 fi
579
580 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
581 then
582         echo >&2 'You need to build test-chmtime:'
583         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
584         exit 1
585 fi
586
587 # Test repository
588 test="trash directory.$(basename "$0" .sh)"
589 test -n "$root" && test="$root/$test"
590 case "$test" in
591 /*) TRASH_DIRECTORY="$test" ;;
592  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
593 esac
594 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
595 rm -fr "$test" || {
596         GIT_EXIT_OK=t
597         echo >&5 "FATAL: Cannot prepare test area"
598         exit 1
599 }
600
601 HOME="$TRASH_DIRECTORY"
602 export HOME
603
604 if test -z "$TEST_NO_CREATE_REPO"
605 then
606         test_create_repo "$test"
607 else
608         mkdir -p "$test"
609 fi
610 # Use -P to resolve symlinks in our working directory so that the cwd
611 # in subprocesses like git equals our $PWD (for pathname comparisons).
612 cd -P "$test" || exit 1
613
614 this_test=${0##*/}
615 this_test=${this_test%%-*}
616 for skp in $GIT_SKIP_TESTS
617 do
618         case "$this_test" in
619         $skp)
620                 say_color skip >&3 "skipping test $this_test altogether"
621                 skip_all="skip all tests in $this_test"
622                 test_done
623         esac
624 done
625
626 # Provide an implementation of the 'yes' utility
627 yes () {
628         if test $# = 0
629         then
630                 y=y
631         else
632                 y="$*"
633         fi
634
635         while echo "$y"
636         do
637                 :
638         done
639 }
640
641 # Fix some commands on Windows
642 case $(uname -s) in
643 *MINGW*)
644         # Windows has its own (incompatible) sort and find
645         sort () {
646                 /usr/bin/sort "$@"
647         }
648         find () {
649                 /usr/bin/find "$@"
650         }
651         sum () {
652                 md5sum "$@"
653         }
654         # git sees Windows-style pwd
655         pwd () {
656                 builtin pwd -W
657         }
658         # no POSIX permissions
659         # backslashes in pathspec are converted to '/'
660         # exec does not inherit the PID
661         test_set_prereq MINGW
662         test_set_prereq SED_STRIPS_CR
663         ;;
664 *CYGWIN*)
665         test_set_prereq POSIXPERM
666         test_set_prereq EXECKEEPSPID
667         test_set_prereq NOT_MINGW
668         test_set_prereq SED_STRIPS_CR
669         ;;
670 *)
671         test_set_prereq POSIXPERM
672         test_set_prereq BSLASHPSPEC
673         test_set_prereq EXECKEEPSPID
674         test_set_prereq NOT_MINGW
675         ;;
676 esac
677
678 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
679 test -z "$NO_PERL" && test_set_prereq PERL
680 test -z "$NO_PYTHON" && test_set_prereq PYTHON
681 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
682 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
683
684 # Can we rely on git's output in the C locale?
685 if test -n "$GETTEXT_POISON"
686 then
687         GIT_GETTEXT_POISON=YesPlease
688         export GIT_GETTEXT_POISON
689         test_set_prereq GETTEXT_POISON
690 else
691         test_set_prereq C_LOCALE_OUTPUT
692 fi
693
694 # Use this instead of test_cmp to compare files that contain expected and
695 # actual output from git commands that can be translated.  When running
696 # under GETTEXT_POISON this pretends that the command produced expected
697 # results.
698 test_i18ncmp () {
699         test -n "$GETTEXT_POISON" || test_cmp "$@"
700 }
701
702 # Use this instead of "grep expected-string actual" to see if the
703 # output from a git command that can be translated either contains an
704 # expected string, or does not contain an unwanted one.  When running
705 # under GETTEXT_POISON this pretends that the command produced expected
706 # results.
707 test_i18ngrep () {
708         if test -n "$GETTEXT_POISON"
709         then
710             : # pretend success
711         elif test "x!" = "x$1"
712         then
713                 shift
714                 ! grep "$@"
715         else
716                 grep "$@"
717         fi
718 }
719
720 test_lazy_prereq SYMLINKS '
721         # test whether the filesystem supports symbolic links
722         ln -s x y && test -h y
723 '
724
725 test_lazy_prereq CASE_INSENSITIVE_FS '
726         echo good >CamelCase &&
727         echo bad >camelcase &&
728         test "$(cat CamelCase)" != good
729 '
730
731 test_lazy_prereq UTF8_NFD_TO_NFC '
732         # check whether FS converts nfd unicode to nfc
733         auml=$(printf "\303\244")
734         aumlcdiar=$(printf "\141\314\210")
735         >"$auml" &&
736         case "$(echo *)" in
737         "$aumlcdiar")
738                 true ;;
739         *)
740                 false ;;
741         esac
742 '
743
744 test_lazy_prereq AUTOIDENT '
745         sane_unset GIT_AUTHOR_NAME &&
746         sane_unset GIT_AUTHOR_EMAIL &&
747         git var GIT_AUTHOR_IDENT
748 '
749
750 # When the tests are run as root, permission tests will report that
751 # things are writable when they shouldn't be.
752 test -w / || test_set_prereq SANITY